Index: trunk/Install/deb/build.sh
===================================================================
--- trunk/Install/deb/build.sh	(revision 76)
+++ trunk/Install/deb/build.sh	(revision 76)
@@ -0,0 +1,11 @@
+#!/bin/bash
+
+# 64-bit
+#ARCH=x86_64-linux
+
+BUILD_ROOT=/tmp/build-root/estetistic
+mkdir -p $BUILD_ROOT
+cp -r -f ../.. $BUILD_ROOT
+cp -r -f debian $BUILD_ROOT
+cd $BUILD_ROOT
+dpkg-buildpackage -b -rfakeroot -us -uc
Index: trunk/Install/deb/debian/changelog
===================================================================
--- trunk/Install/deb/debian/changelog	(revision 76)
+++ trunk/Install/deb/debian/changelog	(revision 76)
@@ -0,0 +1,5 @@
+estetistic (1.0.0-0) precise; urgency=low
+
+  * Original version 
+
+ -- Chronos <robie@centrum.cz>  Sun, 17 Dec 2016 00:51:08 +0100
Index: trunk/Install/deb/debian/compat
===================================================================
--- trunk/Install/deb/debian/compat	(revision 76)
+++ trunk/Install/deb/debian/compat	(revision 76)
@@ -0,0 +1,1 @@
+8
Index: trunk/Install/deb/debian/conf/Config.php
===================================================================
--- trunk/Install/deb/debian/conf/Config.php	(revision 76)
+++ trunk/Install/deb/debian/conf/Config.php	(revision 76)
@@ -0,0 +1,43 @@
+<?php
+
+$Config = array(
+  'SystemPassword' => sha1(random(100000)),
+  'Database' => array(
+    'Host' => 'localhost',
+    'User' => 'estetistic',
+    'Password' => 'password',
+    'Database' => 'estetistic',
+    'Prefix' => '',
+    'Charset' => 'utf8',
+  ),
+  'AddNewValueUrl' => 'http://localhost/estetistic/add.php',
+  'Debug' => 0,
+  'Web' => array(
+    'Title' => 'Estetistic',
+    'Charset' => 'utf-8',
+    'AdminEmail' => 'user@local.domain',
+    'ShowSQLError' => false,
+    'ShowSQLQuery' => false,
+    'ShowError' => false,
+    'ErrorLogFile' => 'php_script_error.log',    
+    'ItemsPerPage' => 30,
+    'VisiblePagingItems' => 10,
+  ),
+  'DivisionCount' => 500,
+  'LevelReducing' => 5,
+  'MaxLevel' => 4,
+  'ReferenceTime' => 0,
+  'ImageWidth' => 750,
+  'ImageHeight' => 200,
+  'ValueToImageHeigthCoefficient' => 0.9,
+  'FontFileName' => './arial.ttf',
+  'FontSize' => 10,
+  'DefaultVariables' => array(
+    'TimeStart' => time() - 3600*24,
+    'TimeEnd' => time(),
+    'Measure' => 1,
+    'Period' => 'day',
+    'TimeSpecify' => 0,
+    'Differential' => 0,
+  ),
+);
Index: trunk/Install/deb/debian/conf/Modules.php
===================================================================
--- trunk/Install/deb/debian/conf/Modules.php	(revision 76)
+++ trunk/Install/deb/debian/conf/Modules.php	(revision 76)
@@ -0,0 +1,11 @@
+<?php 
+
+$ConfigModules = array (
+  0 => 
+  array (
+    'Name' => 'Measure',
+    'Enabled' => true,
+    'Version' => '1.0',
+    'Installed' => true,
+  ),
+);
Index: trunk/Install/deb/debian/conf/apache.conf
===================================================================
--- trunk/Install/deb/debian/conf/apache.conf	(revision 76)
+++ trunk/Install/deb/debian/conf/apache.conf	(revision 76)
@@ -0,0 +1,7 @@
+# Estetistic default Apache configuration
+
+Alias /estetistic /usr/share/estetistic
+
+<Directory /usr/share/estetistic>
+    DirectoryIndex index.php
+</Directory>
Index: trunk/Install/deb/debian/control
===================================================================
--- trunk/Install/deb/debian/control	(revision 76)
+++ trunk/Install/deb/debian/control	(revision 76)
@@ -0,0 +1,12 @@
+Source: estetistic
+Maintainer: Chronos <robie@centrum.cz>
+Section: devel
+Priority: optional
+Standards-Version: 1.0.0
+Build-Depends: debhelper (>= 8)
+
+Package: estetistic
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, apache2, php, dbconfig-mysql
+Description: Simple BrainFuck IDE written in Lazarus/FPC.
+HomePage: http://svn.zdechov.net/trac/LazFuck
Index: trunk/Install/deb/debian/copyright
===================================================================
--- trunk/Install/deb/debian/copyright	(revision 76)
+++ trunk/Install/deb/debian/copyright	(revision 76)
@@ -0,0 +1,22 @@
+Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+
+Files: *
+Copyright: 2016 Chronosoft
+License: GPL-2+
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2 of the License, or
+ at your option) any later version.
+ .
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+ .
+ You should have received a copy of the GNU General Public License along
+ with this program; if not, write to the Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ .
+ On Debian systems, the full text of the GNU General Public
+ License version 2 can be found in the file
+ /usr/share/common-licenses/GPL-2
Index: trunk/Install/deb/debian/install
===================================================================
--- trunk/Install/deb/debian/install	(revision 76)
+++ trunk/Install/deb/debian/install	(revision 76)
@@ -0,0 +1,9 @@
+*.php usr/share/estetistic
+*.ttf usr/share/estetistic
+
+Modules usr/share/estetistic
+Application usr/share/estetistic
+Packages usr/share/estetistic
+style usr/share/estetistic
+
+debian/conf/*	etc/estetistic
Index: trunk/Install/deb/debian/postinst
===================================================================
--- trunk/Install/deb/debian/postinst	(revision 76)
+++ trunk/Install/deb/debian/postinst	(revision 76)
@@ -0,0 +1,22 @@
+#!/bin/sh
+# postinst script for estetistic
+
+apache_install() {
+	mkdir -p /etc/apache2/conf-available
+	ln -sf ../../estetistic/apache.conf /etc/apache2/conf-available/estetistic.conf
+	
+	COMMON_STATE=$(dpkg-query -f '${Status}' -W 'apache2.2-common' 2>/dev/null | awk '{print $3}' || true)
+
+	if [ -e /usr/share/apache2/apache2-maintscript-helper ] ; then
+		. /usr/share/apache2/apache2-maintscript-helper
+		apache2_invoke enconf estetistic
+	elif [ "$COMMON_STATE" = "installed" ] || [ "$COMMON_STATE" = "unpacked" ] ; then
+		[ -d /etc/apache2/conf.d/ ] && [ ! -L /etc/apache2/conf.d/estetistic.conf ] && ln -s ../conf-available/estetistic.conf /etc/apache2/conf.d/estetistic.conf
+	fi
+}
+
+if [ "$1" = "configure" ]; then
+	apache_install() $@
+fi
+
+exit 0
Index: trunk/Install/deb/debian/postrm
===================================================================
--- trunk/Install/deb/debian/postrm	(revision 76)
+++ trunk/Install/deb/debian/postrm	(revision 76)
@@ -0,0 +1,23 @@
+#!/bin/sh
+# postrm script for estetistic
+
+set -e
+
+apache_remove() {
+        COMMON_STATE=$(dpkg-query -f '${Status}' -W 'apache2.2-common' 2>/dev/null | awk '{print $3}' || true)
+
+        if [ -e /usr/share/apache2/apache2-maintscript-helper ] ; then
+                . /usr/share/apache2/apache2-maintscript-helper
+                apache2_invoke disconf estetistic
+        elif [ "$COMMON_STATE" = "installed" ] || [ "$COMMON_STATE" = "unpacked" ] ; then
+                rm -f /etc/apache2/conf.d/estetistic.conf
+        fi
+
+	rm -f /etc/apache2/conf-available/estetistic.conf
+}
+
+if [ "$1" = "remove" ] || [ "$1" = "purge" ]; then
+	apache_remove() $1
+fi
+
+exit 0
Index: trunk/Install/deb/debian/rules
===================================================================
--- trunk/Install/deb/debian/rules	(revision 76)
+++ trunk/Install/deb/debian/rules	(revision 76)
@@ -0,0 +1,16 @@
+#!/usr/bin/make -f
+
+ROOT = $(CURDIR)/debian/estetistic
+
+override_dh_auto_clean:
+	$(RM) -r Install
+	$(RM) Install
+
+override_dh_auto_build:	
+	echo 1
+
+override_dh_auto_install:
+	echo 1
+
+%:
+	dh $@
Index: trunk/Install/deb/debian/source/format
===================================================================
--- trunk/Install/deb/debian/source/format	(revision 76)
+++ trunk/Install/deb/debian/source/format	(revision 76)
@@ -0,0 +1,1 @@
+3.0 (quilt)