Index: /trunk/Install/deb/build.sh
===================================================================
--- /trunk/Install/deb/build.sh	(revision 112)
+++ /trunk/Install/deb/build.sh	(revision 112)
@@ -0,0 +1,10 @@
+#!/bin/bash
+
+# 64-bit
+#ARCH=x86_64-linux
+
+mkdir -p /tmp/build-root
+cp -r -f ../.. /tmp/build-root
+cp -r -f debian /tmp/build-root
+cd /tmp/build-root
+dpkg-buildpackage -b -rfakeroot -us -uc
Index: /trunk/Install/deb/debian/changelog
===================================================================
--- /trunk/Install/deb/debian/changelog	(revision 112)
+++ /trunk/Install/deb/debian/changelog	(revision 112)
@@ -0,0 +1,5 @@
+xtactics (1.0.0-1) precise; urgency=low
+
+  * Original version 1.0.0 packaged with lazdebian
+
+ -- Chronos <robie@centrum.cz>  Sun, 27 Nov 2016 00:51:08 +0100
Index: /trunk/Install/deb/debian/compat
===================================================================
--- /trunk/Install/deb/debian/compat	(revision 112)
+++ /trunk/Install/deb/debian/compat	(revision 112)
@@ -0,0 +1,1 @@
+8
Index: /trunk/Install/deb/debian/control
===================================================================
--- /trunk/Install/deb/debian/control	(revision 112)
+++ /trunk/Install/deb/debian/control	(revision 112)
@@ -0,0 +1,12 @@
+Source: xtactics
+Maintainer: Chronos <robie@centrum.cz>
+Section: utils
+Priority: optional
+Standards-Version: 1.0.0
+Build-Depends: fpc, lazarus, lcl, lcl-utils, debhelper (>= 8)
+
+Package: xtactics
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends},
+Description: Turn-based strategic war game inspired by Risk board game. 
+HomePage: http://svn.zdechov.net/trac/xtactics
Index: /trunk/Install/deb/debian/copyright
===================================================================
--- /trunk/Install/deb/debian/copyright	(revision 112)
+++ /trunk/Install/deb/debian/copyright	(revision 112)
@@ -0,0 +1,22 @@
+Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+
+Files: *
+Copyright: 2016 Chronosoft
+License: GPL-2+
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2 of the License, or
+ at your option) any later version.
+ .
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+ .
+ You should have received a copy of the GNU General Public License along
+ with this program; if not, write to the Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ .
+ On Debian systems, the full text of the GNU General Public
+ License version 2 can be found in the file
+ /usr/share/common-licenses/GPL-2
Index: /trunk/Install/deb/debian/rules
===================================================================
--- /trunk/Install/deb/debian/rules	(revision 112)
+++ /trunk/Install/deb/debian/rules	(revision 112)
@@ -0,0 +1,27 @@
+#!/usr/bin/make -f
+
+ROOT = $(CURDIR)/debian/xtactics
+
+override_dh_auto_clean:
+	$(RM) -r lib
+	$(RM) lib *.res xtactics
+
+override_dh_auto_build:
+	lazbuild --build-mode=Release xtactics.lpi
+
+override_dh_auto_install:
+	install -d -m 755 $(ROOT)/usr/bin
+	install -s -m 755 xtactics $(ROOT)/usr/bin
+	install -d -m 755 $(ROOT)/usr/share/xtactics/languages
+	install -m 755 Languages/xtactics.po $(ROOT)/usr/share/xtactics/languages
+	install -m 755 Languages/xtactics.cs.po $(ROOT)/usr/share/xtactics/languages
+	install -d -m 755 $(ROOT)/usr/share/xtactics/images/maps
+	install -m 755 Images/Maps/Europe.png $(ROOT)/usr/share/xtactics/images/maps
+	install -m 755 Images/Maps/WorldMap.png $(ROOT)/usr/share/xtactics/images/maps
+	install -d -m 755 $(ROOT)/usr/share/applications
+	install -m 755 Install/deb/xtactics.desktop $(ROOT)/usr/share/applications
+	install -d -m 755 $(ROOT)/usr/share/pixmaps
+	install -m 755 Images/64x64/xtactics.png $(ROOT)/usr/share/pixmaps
+
+%:
+	dh $@
Index: /trunk/Install/deb/debian/source/format
===================================================================
--- /trunk/Install/deb/debian/source/format	(revision 112)
+++ /trunk/Install/deb/debian/source/format	(revision 112)
@@ -0,0 +1,1 @@
+3.0 (quilt)
Index: /trunk/Install/deb/xtactics.desktop
===================================================================
--- /trunk/Install/deb/xtactics.desktop	(revision 112)
+++ /trunk/Install/deb/xtactics.desktop	(revision 112)
@@ -0,0 +1,10 @@
+[Desktop Entry]
+Encoding=UTF-8
+Name=xTactics
+Comment=Turn-based strategy game inspired by Risk board game.
+Exec=xtactics
+Icon=xtactics
+Terminal=false
+Type=Application
+Categories=GNOME;Application;Game;
+StartupNotify=true