Index: /tags/1.0.0/Release notes.txt
===================================================================
--- /tags/1.0.0/Release notes.txt	(revision 118)
+++ /tags/1.0.0/Release notes.txt	(revision 118)
@@ -0,0 +1,31 @@
+Version 1.0.0 (2016-12-10)
+==========================
+
+* Added: Zoomable map.
+* Added: Store application configuration in XML file.
+* Added: Allow to save and load game to game file in XML format with extension .xtg.
+* Added: Localization support. Additional language is Czech.
+* Added: High DPI support.
+* Added: Multiple map cell shapes as hexagons, squares and triangles.
+* Added: Bridges between remote cells visible as lines.
+* Added: Multiple players support. Players can have different color and other starting properties.
+* Added: Application now automatically open saved game file given as command line parameter after execution.
+* Added: Computer player settings to be low, medium or highly aggresive in attacking.
+* Added: Holding SHIFT key during click to attack maximum available power is moved without dialog confirmation.
+* Added: With mouse click and with CTRL key pressed new move will set maximum one time and repeated unit counts to selected target cell.
+* Added: New game option "Fog of war" which cause map to be covered to black and only explored cells will be visible.
+* Added: Auto save game to file option in settings.
+* Added: New game option "Map shape" which can use image in file as base for map generation. Black color is used as void.
+* Added: Support for symetric map usable for two players game.
+* Added: Confirmation dialog for ending game.
+* Added: Support for switching large icons in toolbar.
+* Added: About form with information about application.
+* Added: Support for cities. Cities can be used as only growing cells.
+* Added: Allow to set grow rate as square root of cell power.
+* Added: Amount of inaccessible cells can be adjusted in New game dialog.
+* Added: Player customize dialog window.
+* Added: Toolbar for quick access to common actions.
+* Added: Player start units setting.
+* Added: Size of map can be adjusted in New game dialog.
+* Added: Visualization of planned moves between cells for next turn.
+* Added: Player mode human or computer. 
Index: /trunk/Release notes.txt
===================================================================
--- /trunk/Release notes.txt	(revision 118)
+++ /trunk/Release notes.txt	(revision 118)
@@ -0,0 +1,31 @@
+Version 1.0.0 (2016-12-10)
+==========================
+
+* Added: Zoomable map.
+* Added: Store application configuration in XML file.
+* Added: Allow to save and load game to game file in XML format with extension .xtg.
+* Added: Localization support. Additional language is Czech.
+* Added: High DPI support.
+* Added: Multiple map cell shapes as hexagons, squares and triangles.
+* Added: Bridges between remote cells visible as lines.
+* Added: Multiple players support. Players can have different color and other starting properties.
+* Added: Application now automatically open saved game file given as command line parameter after execution.
+* Added: Computer player settings to be low, medium or highly aggresive in attacking.
+* Added: Holding SHIFT key during click to attack maximum available power is moved without dialog confirmation.
+* Added: With mouse click and with CTRL key pressed new move will set maximum one time and repeated unit counts to selected target cell.
+* Added: New game option "Fog of war" which cause map to be covered to black and only explored cells will be visible.
+* Added: Auto save game to file option in settings.
+* Added: New game option "Map shape" which can use image in file as base for map generation. Black color is used as void.
+* Added: Support for symetric map usable for two players game.
+* Added: Confirmation dialog for ending game.
+* Added: Support for switching large icons in toolbar.
+* Added: About form with information about application.
+* Added: Support for cities. Cities can be used as only growing cells.
+* Added: Allow to set grow rate as square root of cell power.
+* Added: Amount of inaccessible cells can be adjusted in New game dialog.
+* Added: Player customize dialog window.
+* Added: Toolbar for quick access to common actions.
+* Added: Player start units setting.
+* Added: Size of map can be adjusted in New game dialog.
+* Added: Visualization of planned moves between cells for next turn.
+* Added: Player mode human or computer. 